diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 32cf8f1b6..e8f021467 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -11,6 +11,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.PackedField;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -38,58 +39,50 @@ public class BlockLogicBed
         int data = world.getBlockData(tilePos);
         final @NotNull TilePosc headPos;
         final @NotNull TilePosc footPos;
-        if (!isBlockHeadOfBed(data)) {
-            final int dir = getDirection(data);
+        if (!IS_HEAD.bool(data)) {
+            final int dir = DIRECTION.get(data);
             headPos = tilePos;
             footPos = tilePos.add(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
+            if (world.getBlockType(footPos) != this.block) return true;
         } else {
-            final int dir = getDirection(data);
-            headPos = tilePos.sub(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
+            final int dir = DIRECTION.get(data);
             footPos = tilePos;
-        }
-
-        // Check if bed is not complete
-        if (!isBlockHeadOfBed(data)) {
-            if (world.getBlockType(footPos) != this.block) {
-                return true;
-            }
-            data = world.getBlockData(tilePos);
+            headPos = tilePos.sub(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
+            if (world.getBlockType(headPos) != this.block) return true;
         }
 
         // Explode in invalid dimensions
         if (!world.getWorldType().mayRespawn()) {
-            world.setBlockTypeNotify(tilePos, Blocks.AIR);
-            if (world.getBlockType(footPos) == this.block) {
-                world.setBlockTypeNotify(footPos, Blocks.AIR);
-            }
+            world.setBlockType(headPos, Blocks.AIR);
+            assert world.getBlockType(footPos) == this.block; // made sure from above
+            world.setBlockType(footPos, Blocks.AIR);
+
+            // prevents dupe... tho the dupe would need to be pretty funny to work
+            world.notifyBlockChange(headPos, Blocks.AIR); 
+            world.notifyBlockChange(footPos, Blocks.AIR); 
+
             player.addStat(Achievements.SLEEP_NETHER, 1);
             world.createExplosion(null, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, 5F, true, false);
             return true;
         }
 
         // Check if bed is occupied, and set occupied
-        if (isBedOccupied(data)) {
-            @Nullable Player sleepingPlayer = null;
+        if (IS_OCCUPIED.bool(data)) {
+            // @Nullable Player sleepingPlayer = null;
             for (final @NotNull Player p : world.players) {
-                if (p.isPlayerSleeping()) {
-                    final @NotNull TilePos pos = Objects.requireNonNull(p.bedTilePos);
-                    if (pos.equals(footPos)) {
-                        sleepingPlayer = p;
-                    }
+                if (!p.isPlayerSleeping()) continue;
+                final var otherBedPos = Objects.requireNonNull(p.bedTilePos);
+                if (otherBedPos.equals(footPos)) {
+                    player.sendTranslatedChatMessage("bed.occupied");
+                    return true;
                 }
             }
-            if (sleepingPlayer == null) {
-                setBedOccupied(world, footPos, false);
-            } else {
-                player.sendTranslatedChatMessage("bed.occupied");
-                return true;
-            }
+            world.setBlockData(footPos, IS_OCCUPIED.set(data, 0));
         }
-
+        
         // Sleep
         if (player.sleepInBedAt(footPos.x(), footPos.y(), footPos.z()) == EnumSleepStatus.OK) {
-            setBedOccupied(world, footPos, true);
-            return true;
+            world.setBlockData(footPos, IS_OCCUPIED.set(data, 1));
         }
 
         return true;
@@ -112,51 +105,41 @@ public class BlockLogicBed
 
     @Override
     public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        final var state = new State(world, tilePos);
-        if (!state.hasOtherHalf(world, tilePos)) {
+        final var otherHalf = otherHalf(world, tilePos, world.getBlockData(tilePos));
+        if (otherHalf == null) {
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     @Override
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
-        final var state = new State(data, world, tilePos);
-        if (state.hasOtherHalf(world, tilePos)) {
+        final var otherHalf = otherHalf(world, tilePos, data);
+        if (otherHalf != null) {
             // eventhough onNeighborChanged would normally be able to handle the removal of
             // the other half, however piston will break this half without emitting neighbor
             // update untill it finishes extending, destroying the other half before which
             // would result in a dupe.
-            world.setBlockTypeNotify(state.otherPos(tilePos), Blocks.AIR);
+            world.setBlockTypeNotify(otherHalf, Blocks.AIR);
         }
     }
 
-    protected static class State {
-        final boolean isHead;
-        final @NotNull Direction h2fDir;
+    public static final PackedField DIRECTION = new PackedField(0, 2); 
+    public static final PackedField IS_OCCUPIED = new PackedField(2, 1); 
+    public static final PackedField IS_HEAD = new PackedField(3, 1); 
 
-        public State(int data, final @NotNull World world, @NotNull TilePosc tilePos) {
-            isHead = isBlockHeadOfBed(data);
-            h2fDir = headBlockToFootBlockMap[getDirection(data)].getDirection();
-        }
-
-        public State(final @NotNull World world, @NotNull TilePosc tilePos) {
-            this(world.getBlockData(tilePos), world, tilePos);
-        }    
-
-        public @NotNull TilePos otherPos(@NotNull TilePosc tilePos) {
-            return (isHead)
-                ? tilePos.sub(h2fDir, new TilePos())
-                : tilePos.add(h2fDir, new TilePos());
-        }
+    public static @Nullable TilePos otherHalf(final @NotNull World world, @NotNull TilePosc tilePos, int data) {
+        final var isHead = IS_HEAD.bool(data);
+        final var dir = DIRECTION.get(data);
+        final var direction = headBlockToFootBlockMap[DIRECTION.get(data)].getDirection();
+        final var otherPos = (isHead)
+            ? tilePos.sub(direction, new TilePos())
+            : tilePos.add(direction, new TilePos());
 
-        public boolean hasOtherHalf(final @NotNull World world, @NotNull TilePosc tilePos) {
-            final var otherPos = otherPos(tilePos);
-            if (!(world.getBlockType(otherPos).getLogic() instanceof BlockLogicBed)) return false;
-            final var otherState = new State(world, otherPos);
-            if (this.isHead == otherState.isHead) return false;
-            if (this.h2fDir != otherState.h2fDir) return false;
-            return true;
-        }
+        if (!(world.getBlockType(otherPos).getLogic() instanceof BlockLogicBed)) return null;
+        final int otherData = world.getBlockData(otherPos);
+        if (isHead == IS_HEAD.bool(otherData)) return null;
+        if (dir != DIRECTION.get(otherData)) return null;
+        return otherPos;
     }
 
     @Override
@@ -169,35 +152,8 @@ public class BlockLogicBed
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
-    public static final int MASK_IS_HEAD = 0b0000_1000;
-    public static final int MASK_IS_OCCUPIED = 0b0000_0100;
-    public static final int MASK_DIRECTION = 0b0000_0011;
-
-    public static boolean isBlockHeadOfBed(final int meta) {
-        return (meta & MASK_IS_HEAD) != 0;
-    }
-
-    public static boolean isBedOccupied(final int meta) {
-        return (meta & MASK_IS_OCCUPIED) != 0;
-    }
-
-    public static int getDirection(final int meta) {
-        return meta & MASK_DIRECTION;
-    }
-
-    public static void setBedOccupied(final @NotNull World world, final @NotNull TilePosc tilePos, final boolean flag) {
-        int l = world.getBlockData(tilePos);
-        if (flag) {
-            l |= MASK_IS_OCCUPIED;
-        } else {
-            l &= ~MASK_IS_OCCUPIED;
-        }
-        world.setBlockDataNotify(tilePos, l);
-    }
-
     public static @Nullable TilePos getNearestEmptyTilePos(final @NotNull World world, final @NotNull TilePos tilePos, int attempts) {
-        final int data = world.getBlockData(tilePos);
-        final int direction = getDirection(data);
+        final int direction = DIRECTION.get(world.getBlockData(tilePos));
 
         for (int d = 0; d <= 1; d++) {
             final @NotNull TilePos minPos = new TilePos(
@@ -230,29 +186,10 @@ public class BlockLogicBed
         return null;
     }
 
-    public static final int[] headOfBedMap = {
-        3, 4, 2, 5
+    public static final @NotNull Side @NotNull [] headBlockToFootBlockMap = {
+        Side.SOUTH,
+        Side.WEST,
+        Side.NORTH,
+        Side.EAST
     };
-    public static final int[] footToHeadMap = {
-        2, 3, 0, 1
-    };
-    public static final int[][] bedDirection = {
-        {
-            1, 0, 3, 2, 5, 4
-        }, {
-        1, 0, 5, 4, 2, 3
-    }, {
-        1, 0, 2, 3, 4, 5
-    }, {
-        1, 0, 4, 5, 3, 2
-    }
-    };
-
-    public static final @NotNull Side @NotNull [] headBlockToFootBlockMap =
-        {
-            Side.SOUTH,
-            Side.WEST,
-            Side.NORTH,
-            Side.EAST
-        };
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index a64af88db..d7163bb7e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -27,6 +27,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.function.Supplier;
 
+// TODO this needs massive refactor
 public class BlockLogicDoor
     extends BlockLogic
     implements IPaintable {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
index 84b830ae8..7e8b34df3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoorPainted.java
@@ -42,22 +42,24 @@ public class BlockLogicDoorPainted
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos);
-        world.setBlockTypeDataNotify(tilePos, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP : Blocks.DOOR_PLANKS_OAK_BOTTOM, data & 0xF);
+        world.setBlockTypeData(tilePos, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP : Blocks.DOOR_PLANKS_OAK_BOTTOM, data & 0xF);
         if (this.isTop) {
             world.setBlockTypeDataNotify(tilePos.down(new TilePos()), Blocks.DOOR_PLANKS_OAK_BOTTOM, data & 0xF);
         } else {
             world.setBlockTypeDataNotify(tilePos.up(new TilePos()), Blocks.DOOR_PLANKS_OAK_TOP, data & 0xF);
         }
+        world.notifyBlockChange(tilePos, this.block);
     }
-
+    
     @Override
     public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int data = world.getBlockData(tilePos);
-        world.setBlockDataNotify(tilePos, data & 0xF | this.toMetadata(color));
+        world.setBlockData(tilePos, data & 0xF | this.toMetadata(color));
         if (this.isTop) {
             world.setBlockDataNotify(tilePos.down(new TilePos()), data & 0xF | this.toMetadata(color));
         } else {
             world.setBlockDataNotify(tilePos.up(new TilePos()), data & 0xF | this.toMetadata(color));
         }
+        world.notifyBlockChange(tilePos, this.block);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 558b84a1c..89f9f5c6c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -41,7 +41,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
         return (float) (data + 1) / 8F;
     }
 
-    protected int getDepth(final WorldSource worldSource, final @NotNull TilePosc tilePos) {
+    public int getDepth(final WorldSource worldSource, final @NotNull TilePosc tilePos) {
         if (worldSource.getBlockMaterial(tilePos) != this.material) {
             return -1;
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index d8ac4e7b0..5a927c736 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -48,13 +48,11 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             if (newFlowDecay >= 8 || surroundingFlowDecay < 0) {
                 newFlowDecay = -1;
             }
-            if (getDepth(world, tilePos.up(queryPos)) >= 0) {
-                int flowDecayAbove = getDepth(world, tilePos.up(queryPos));
-                if (flowDecayAbove >= 8) {
-                    newFlowDecay = flowDecayAbove;
-                } else {
-                    newFlowDecay = flowDecayAbove + 8;
-                }
+            int flowDecayAbove = getDepth(world, tilePos.up(queryPos));
+            if (flowDecayAbove >= 8) {
+                newFlowDecay = flowDecayAbove;
+            } else if (flowDecayAbove >= 0) {
+                newFlowDecay = flowDecayAbove + 8;
             }
             // Become source block
             if (this.maxCount >= 2 && this.fluid.canBecomeSource(this, world, tilePos, rand)) {
@@ -71,7 +69,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
                 } else {
                     world.setBlockDataNotify(tilePos, localFlowDecay);
                     world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
-                    world.notifyBlocksOfNeighborChange(tilePos, this.block);
+                    world.notifyBlocksOfNeighborChange(tilePos, this.block); // ?
                 }
             } else {
                 setFluidStill(world, tilePos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
index d85e55d52..1b9e33702 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnace.java
@@ -20,7 +20,6 @@ import java.util.Random;
 
 public class BlockLogicFurnace extends BlockLogicRotatable {
     private static final Logger LOGGER = LogUtils.getLogger();
-    public static boolean keepFurnaceInventory = false;
 
     protected final boolean isActive;
 
@@ -78,9 +77,7 @@ public class BlockLogicFurnace extends BlockLogicRotatable {
     }
 
     public static void updateFurnaceBlockState(@NotNull World world, @NotNull TilePos tilePos, boolean lit) {
-        int meta = world.getBlockData(tilePos);
-        TileEntity tileEntity = world.getTileEntity(tilePos);
-        if (tileEntity == null) {
+        if (!(world.getTileEntity(tilePos) instanceof TileEntityFurnace)) {
             String msg = "Furnace is missing Tile Entity at " + tilePos + ", block will be removed!";
             if (Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
@@ -89,16 +86,11 @@ public class BlockLogicFurnace extends BlockLogicRotatable {
             LOGGER.warn(msg);
             return;
         }
-        keepFurnaceInventory = true;
-        if (lit) {
-            world.setBlockTypeNotify(tilePos, Blocks.FURNACE_STONE_ACTIVE);
-        } else {
-            world.setBlockTypeNotify(tilePos, Blocks.FURNACE_STONE_IDLE);
-        }
-        keepFurnaceInventory = false;
-        world.setBlockDataNotify(tilePos, meta);
-        tileEntity.validate();
-        world.setTileEntity(tilePos, tileEntity);
+        final int meta = world.getBlockData(tilePos);
+        final var block = (lit)
+            ? Blocks.FURNACE_STONE_ACTIVE
+            : Blocks.FURNACE_STONE_IDLE;
+        world.setBlockTypeDataRaw(tilePos, block, meta);
+        world.notifyBlockChange(tilePos, block);
     }
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
index 211ee3511..d5610e1ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFurnaceBlast.java
@@ -23,7 +23,6 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
     private static final Logger LOGGER = LogUtils.getLogger();
 
     protected final boolean isActive;
-    public static boolean keepFurnaceInventory = false;
 
     public BlockLogicFurnaceBlast(Block<?> block, boolean active)
     {
@@ -81,27 +80,21 @@ public class BlockLogicFurnaceBlast extends BlockLogicRotatable
     }
 
     public static void updateFurnaceBlockState(@NotNull World world, @NotNull TilePos tilePos, boolean lit) {
-		int meta = world.getBlockData(tilePos);
-		TileEntity tileEntity = world.getTileEntity(tilePos);
-		if(tileEntity == null) {
-			String msg = "Blast Furnace is missing Tile Entity at " + tilePos + ", block will be removed!";
+        if(!(world.getTileEntity(tilePos) instanceof TileEntityFurnaceBlast)) {
+            String msg = "Blast Furnace is missing Tile Entity at " + tilePos + ", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
-				throw new RuntimeException(msg);
+                throw new RuntimeException(msg);
 			}
 			world.setBlockTypeNotify(tilePos, Blocks.AIR);
             LOGGER.warn(msg);
 			return;
 		}
-		keepFurnaceInventory = true;
-		if(lit) {
-			world.setBlockTypeNotify(tilePos, Blocks.FURNACE_BLAST_ACTIVE);
-		} else {
-			world.setBlockTypeNotify(tilePos, Blocks.FURNACE_BLAST_IDLE);
-		}
-		keepFurnaceInventory = false;
-		world.setBlockDataNotify(tilePos, meta);
-		tileEntity.validate();
-		world.setTileEntity(tilePos, tileEntity);
+        final int meta = world.getBlockData(tilePos);
+        final var block = (lit)
+            ? Blocks.FURNACE_BLAST_ACTIVE
+            : Blocks.FURNACE_BLAST_IDLE;
+		world.setBlockTypeDataRaw(tilePos, block, meta);
+        world.notifyBlockChange(tilePos, block);
 	}
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index a546093c9..d21de68de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -44,13 +44,10 @@ public class BlockLogicJukebox extends BlockLogic {
         }
     }
 
-    public void ejectRecord(@NotNull World world, @NotNull TilePosc tilePos)
-    {
-        if(world.isClientSide)
-        {
-            return;
+    public void ejectRecord(@NotNull World world, @NotNull TilePosc tilePos) {
+        if(world.isClientSide) return;
+        if (world.getTileEntity(tilePos) instanceof TileEntityJukebox jukebox) {
+            jukebox.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
         }
-        TileEntity tileEntity = world.getTileEntity(tilePos);
-        if (tileEntity != null) tileEntity.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index a6371b971..7969695e9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -12,6 +12,7 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
@@ -74,7 +75,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
         return true;
     }
 
-    public Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
+    public @Nullable Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
         TilePosc p = tilePos;
         if (!world.canPlaceInsideBlock(tilePos)) {
             p = p.add(clickedSide.getDirection(), new TilePos());
@@ -97,7 +98,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
     /**
      * Returns the side of the block the ladder is attached to
      */
-    public Side getSideFromMeta(int meta) {
+    public @NotNull Side getSideFromMeta(int meta) {
         if (meta == 2) return Side.NORTH;
         if (meta == 3) return Side.SOUTH;
         if (meta == 4) return Side.WEST;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 5a0ab3cdd..32902034e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -135,13 +135,13 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         }
         if (isSteppedOn && !isPressed) {
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            // world.notifyBlocksOfNeighborChange(tilePos, this.block);
             world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
         } else if (!isSteppedOn && isPressed) {
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            // world.notifyBlocksOfNeighborChange(tilePos, this.block);
             world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index 0276813f0..c20b3a53b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -13,6 +13,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 
+// TODO detector rail has some freaky behaviors, investigate and fix
 public class BlockLogicRailDetector extends BlockLogicRail {
     public BlockLogicRailDetector(@NotNull Block<?> block) {
         super(block, true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index facc4d952..171e60515 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -31,22 +31,23 @@ public class BlockLogicSponge extends BlockLogic {
                 world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0, false);
             }
         }
-        final byte radius = 2;
+        // TODO this sends far more updates than needed
         if (!this.isWet && inWater(world, tilePos)) {
+            world.setBlockTypeNotify(tilePos, Blocks.SPONGE_WET);
             TilePos queryPos = new TilePos();
-            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
-                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
-                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+            for (queryPos.x = tilePos.x() - RADIUS; queryPos.x <= tilePos.x() + RADIUS; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - RADIUS; queryPos.y <= tilePos.y() + RADIUS; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - RADIUS; queryPos.z <= tilePos.z() + RADIUS; queryPos.z++) {
                         if (world.getBlockType(queryPos).hasTag(BlockTags.IS_WATER)) {
                             world.setBlockTypeNotify(queryPos, Blocks.AIR);
                         }
                     }
                 }
             }
-            world.setBlockTypeNotify(tilePos, Blocks.SPONGE_WET);
         }
     }
 
+    private static final int RADIUS = 2;
 
     public boolean inWater(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
@@ -71,11 +72,10 @@ public class BlockLogicSponge extends BlockLogic {
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (!this.isWet) {
-            byte radius = 2;
             TilePos queryPos = new TilePos(tilePos);
-            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
-                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
-                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+            for (queryPos.x = tilePos.x() - RADIUS; queryPos.x <= tilePos.x() + RADIUS; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - RADIUS; queryPos.y <= tilePos.y() + RADIUS; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - RADIUS; queryPos.z <= tilePos.z() + RADIUS; queryPos.z++) {
                         world.notifyBlocksOfNeighborChange(queryPos, world.getBlockType(queryPos));
                     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
index 37191017c..b48bc5088 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
@@ -18,10 +18,11 @@ import org.slf4j.Logger;
 
 import java.util.Random;
 
+// TODO refactor reuse
+
 public class BlockLogicTrommel extends BlockLogicRotatable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-    public static boolean keepTrommelInventory = false;
     private final boolean isActive;
 
 	public BlockLogicTrommel(@NotNull Block<?> block, @NotNull Material material, boolean isActive)
@@ -62,9 +63,7 @@ public class BlockLogicTrommel extends BlockLogicRotatable
     
     public static void updateTrommelBlockState(@NotNull World world, @NotNull TilePos tilepos, boolean lit)
     {
-        int data = world.getBlockData(tilepos);
-        TileEntity tileEntity = world.getTileEntity(tilepos);
-        if(tileEntity == null) {
+        if(!(world.getTileEntity(tilepos) instanceof TileEntityTrommel)) {
             String msg = "Trommel is missing Tile Entity at " + tilepos + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
                 throw new RuntimeException(msg);
@@ -73,17 +72,9 @@ public class BlockLogicTrommel extends BlockLogicRotatable
             LOGGER.warn(msg);
             return;
         }
-        keepTrommelInventory = true;
-        if(lit)
-        {
-            world.setBlockTypeNotify(tilepos, Blocks.TROMMEL_ACTIVE);
-        } else
-        {
-            world.setBlockTypeNotify(tilepos, Blocks.TROMMEL_IDLE);
-        }
-        keepTrommelInventory = false;
-        world.setBlockDataNotify(tilepos, data);
-        tileEntity.validate();
-        world.setTileEntity(tilepos, tileEntity);
+        final int data = world.getBlockData(tilepos);
+        final var block = (lit) ? Blocks.TROMMEL_ACTIVE : Blocks.TROMMEL_IDLE;
+        world.setBlockTypeDataRaw(tilepos, block, data);
+        world.notifyBlockChange(tilepos, block);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index df435d221..b7a2a0605 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -15,6 +15,8 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -133,6 +135,7 @@ public abstract class TileEntity implements ICarriable
 
     }
 
+    // TODO TilePos refactor
     public void dropContents(World world, int x, int y, int z) {
 
     }
@@ -185,13 +188,7 @@ public abstract class TileEntity implements ICarriable
         carriedBlock.block().dropBlockWithCause(world, EnumDropCause.WORLD, holderX, holderY, holderZ, carriedBlock.metadata, this, null); // TODO this might be scuffed since the position won't have correlated to a real block
     }
 
-    @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
-        return false;
-    }
-
-    @Override
-    public ICarriable pickup(World world, Entity holder) {
+    protected @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos_) {
         Block<?> currentBlock = world.getBlock(tilePos.x, tilePos.y, tilePos.z);
         int currentMeta = world.getBlockMetadata(tilePos.x, tilePos.y, tilePos.z);
         world.removeBlockTileEntity(tilePos.x, tilePos.y, tilePos.z);
